#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>

#define BUFSZ	1024

main(argc,argv)
int	argc;
char	*argv[];
{
static short int c[256];
unsigned char buffer[BUFSZ];

short int i;
int NumErrores=0;
FILE* FTrad;
char FTradName[256];
char WarningMode=0;
char ReplaceMode=0;
unsigned char DefChar; 
unsigned int ErrorEnLinea=0;
unsigned int tmp,j;

extern	char	*optarg;
extern	int	optind,opterr;

int opcion;

	

while ((opcion=getopt(argc,argv,"wr:")) != EOF)
{
	switch(opcion)
	{
		case 'w':	WarningMode = 1;
				break;
		case 'r':	ReplaceMode=1;
				DefChar = optarg[0];
				break;
	}
}

if (argv[optind] == NULL )
{
	fprintf(stderr,"Uso: %s [-rw] fichero\n",argv[0]);
	exit(1);
}
if ( ( FTrad= fopen(argv[optind],"r")) == NULL )
{
	fprintf(stderr,"Error al acceder a %s.\n",argv[optind]);
	exit(1);
}
if ((i=fread((void*)c,1,512,FTrad))!=512)
{
	fprintf(stderr,"Error en el fichero %s.\n",argv[optind]);
	fclose( FTrad );
	exit(1);
}
fclose( FTrad );

/*********************************************************************/


while((tmp=fread((void*)buffer,1,BUFSZ,stdin))>0)
{
	for(j=0; j<tmp;j++)
	{	
	if (buffer[j]==10) ErrorEnLinea++;
	switch(c[buffer[j]])
		{	
		case -1 :	
			if(WarningMode==1)
			fprintf(stderr,
			"Aviso: Caracter no traducible en linea %d.\n",
			ErrorEnLinea);

			if(ReplaceMode==1)
			buffer[j]=DefChar;

			break;

		default:
			buffer[j]=(unsigned char)c[buffer[j]];
			break;
		}
	}
fwrite((void*)buffer,1,tmp,stdout);
}
}
